var VOLUME_STEP = 5;
var DECREASE_STEP_VALUE_ON = 3; /*on which repeated step we reduce VOLUME_STEP*/
var SONOS_PORT = 1400; 

var lInfo = {logln:function (o){}};
var lWarn = {logln:function (o){}};

var LOGFILE_NAME = "sonos-controller.log";
//lInfo = new Logger(LOGFILE_NAME);
//lWarn = new Logger(LOGFILE_NAME);


function upnpParseXMLRespond(szXMLRespond, szXMLFieldName, szContainsText) {
    //lInfo.logln(szXMLRespond);
    var searched_value = '';
    var found = 0;
    var xml_text = '';
    var start_pos = 0;
    
    xml_text = szXMLRespond;
    
    do
    {        
        start_pos = xml_text.indexOf('<' + szXMLFieldName);
        
        if (start_pos == -1)
        {
            break;
        }
        
        start_pos += szXMLFieldName.length + 1;
        start_pos += 1 /* skip '>' */;
        
        var end_pos = xml_text.indexOf('</' + szXMLFieldName);
        
        if (end_pos == -1)
        {
            break;
        };
            
        searched_value = xml_text.substring(start_pos, end_pos);
        
        if (szContainsText != "")
        {
            if (searched_value.indexOf(szContainsText) == -1)
            {
                start_pos = end_pos + szXMLFieldName.length + 1;
                xml_text = xml_text.substring(start_pos, xml_text.length);
                
                lInfo.logln("Filter not match, continue search: : " + xml_text);                
            }
            else
            {
                found = 1;
            }
        }
        else
        {
            found = 1;
        }
    }
    while ((szContainsText != "") && (found == 0) && (xml_text != ""))
    
    return searched_value;
}

function upnpSetRelativeVolume(szIpAddressRenderer, nVolume, oCurlOptions) {
  try {
    var http_headers = [];
    http_headers[''] = 'Content-Type: text/xml; charset="utf-8"';
    http_headers[''] = 'SOAPACTION: "urn:schemas-upnp-org:service:GroupRenderingControl:1#SetRelativeGroupVolume"';

    var h = new HTTP(oCurlOptions, http_headers);
    h.reset();
                           
    var url = 'http://' + szIpAddressRenderer + ':' + SONOS_PORT + '/MediaRenderer/GroupRenderingControl/Control';

    var action = '<?xml version="1.0" encoding="utf-8"?>' 
              + '<s:Envelope s:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/" xmlns:s="http://schemas.xmlsoap.org/soap/envelope/">'
              + '<s:Body>'
                 + '<u:SetRelativeGroupVolume xmlns:u="urn:schemas-upnp-org:service:GroupRenderingControl:1">'
                 + '<InstanceID>0</InstanceID>'
                 + '<Adjustment>' + nVolume + '</Adjustment>'
                 + '</u:SetRelativeGroupVolume>'
              + '</s:Body>'
              + '</s:Envelope>';
 
    //h.post(url, '', action, function (){});//function (sValue){lInfo.logln("\\"+sValue+"\\");}
    h.post(url, '', action);//function (sValue){lInfo.logln("\\"+sValue+"\\");}
  }
  catch (e) {
      lInfo.logln("Error executing upnpSetVolume command " + e);
  }
}

var nTime = new Date().getTime();

/*
lInfo.logln("!VOLUME ONLY!"+startA);
lInfo.logln("sceneID: ", raisedEvent.parameter.sceneID);
lInfo.logln("groupID: ", raisedEvent.parameter.groupID);
  */
//lInfo.logln(JSON.stringify(raisedEvent)); <- Don't know how much JSON.stringify costs 
var nSceneID =  parseInt("" + raisedEvent.parameter.sceneID, 10);
var bSkipStep = false;

var sPlayerIP = "";
var sRoomID = "";
var execPreset = Property.getNode(raisedEvent.parameter.path);
var nStoredStep = 0;
var nStoredStepValue = VOLUME_STEP;
var nStoredLastTime = 0;

if (execPreset != null){
  var nZoneID =  parseInt("" + execPreset.getChild('roomID').getValue(), 10);
  var baseNode = Property.getNode('sonos-players');
  if (baseNode != null) {
    var oArrayNode = baseNode.getChildren();
    for ( var iIndex = 0; iIndex < oArrayNode.length; iIndex++) {
      var oChildNode = oArrayNode[iIndex];
      if ("" + oChildNode.getChild('disabled').getValue()!='true') {
        if (nZoneID == parseInt("" + oChildNode.getChild('roomID').getValue(),10)) {
          sPlayerIP = oChildNode.getChild('ipAddress').getValue();
          sRoomID = oChildNode.getChild('roomID').getValue();
          
          var dimmValue = Property.getNode("dimming");
          var sPath = nSceneID+"-"+sRoomID;
          
          if (dimmValue != null && dimmValue.getChild(sPath) != null) {
            nStoredStep = parseInt(""+dimmValue.getChild(sPath).getValue());
            if (dimmValue.getChild(sPath+"-step") != null)
              nStoredStepValue = parseInt(""+dimmValue.getChild(sPath+"-step").getValue());
            if (dimmValue.getChild(sPath+"-time") != null)
              nStoredLastTime = parseInt(""+dimmValue.getChild(sPath+"-time").getValue());
            
            // if last record volume change is more than 5 seconds we reset values     
            if (nTime != null && nTime - nStoredLastTime > 5000) { 
              nStoredStep = 0;
              nStoredStepValue = VOLUME_STEP;   
              lInfo.logln("Reset volume values"); 
            }
          }

          /* single skip test
          if (dimmValue != null && dimmValue.getChild(sRoomID) != null) {
            dimmValue.removeChild(sRoomID);
            bSkipStep = true;
          }
          else {
            storeSubParameter('dimming', sRoomID, 1);
          } */
          break;
        }
      }
    }
  }
}

var bStoreValues = (nStoredStep == 0);
if (nStoredStep > 0 && (nStoredStep % DECREASE_STEP_VALUE_ON == 0) && nStoredStepValue > 1) {
  nStoredStepValue = nStoredStepValue - 1; 
  bStoreValues = true;
}

lInfo.logln("EXEC STEP="+nStoredStep); 
lInfo.logln("nStoredStepValue="+nStoredStepValue);
 
 var nClearOtherScene = "";
 if (nSceneID == 11)
   nClearOtherScene = 12;
 else
   nClearOtherScene = 11;

 nStoredStep = nStoredStep + 1;
 
 var sPath = nSceneID+"-"+sRoomID;
 var sPathOther = nClearOtherScene+"-"+sRoomID;
 
 Property.setProperty('dimming/'+sPath, nStoredStep);
 Property.setProperty('dimming/'+sPath+"-time", nTime);
 if (bStoreValues) {
	 Property.setProperty('dimming/'+sPath+"-step", nStoredStepValue);
	 Property.setProperty('dimming/'+sPathOther, 0);
	 Property.setProperty('dimming/'+sPathOther+"-step", VOLUME_STEP);
	 Property.setProperty('dimming/'+sPathOther+"-time", 0);
 }

  if (sPlayerIP.length > 0) {
    var curl_options = new Object({'debug' : 0, 'connectTimeout' : 200}); 
    if (nSceneID == 12)
    	upnpSetRelativeVolume(sPlayerIP, nStoredStepValue, curl_options);
	if (nSceneID == 11)
		upnpSetRelativeVolume(sPlayerIP, -1*nStoredStepValue, curl_options);
  }


